#include "genji.h"

#include "netdata.c"
#include "printcom.c"

char	*errmes[8] = {
					"\x0",
					"\x0",
					"v^wG[1ł",
					"v^wG[2ł",
					"p؂Ă܂",
					"v^ItCł",
					"̃y[W̎ZbgĂ",
					"v^s̃G[ł" };

char	pool[256];

void	dataInit()
{
	colrev_flg = OFF;
	pitchmask = 2;	/* truepitch = pitch * pitchmask / 2 */
/*	tabsize = 4;*/
	pitch = 54;		/* Sp̕sb` */
	cr_p = 60;		/* s */
	net_length = 0;
	net_flg = OFF;
	jisflg = OFF;
/*	leftmargin = 0;*/
	pageflg = OFF;
	np = 1;
	info[np][0] = 0;/*ݖ*/
	info[np][1] = KS_XN_YN;/*ݕTCYW*/
	y_pos = 0;
	endflg = OFF;
	page = 1;
	mode = 'A';
	writepage = OFF;
	lnum = 0;
	control = OFF;
	bufp = outbuf;
/*	betaflg = OFF;*/

	return;
}

void	genji_mainPG( char *pdrname, char *defname, int betaflg )
{
	FILE	*fp;
	union
	{
		unsigned short int	sjis;
		char	c[2];
	} moji;
	struct ffblk	fb;
	unsigned int	size;
	int		ch,e,i,j,comflg,sflg;
	char	combuf[16],usrbuf[256],gjbuf[288],gjbuf2[72];
	char	*p;

	dataInit();

	if( findfirst( pdrname, &fb, 0 ) )
	{
		VC_printf( "\"%s\"܂B\n", POINTER, pdrname );
		return;
	}

	size = fb.ff_fsize.high<<16 | fb.ff_fsize.low;

	if( ( file = (char *)malloc( size ) ) == NULL )
	{
		VC_printf( "܂B\n" );
		return;
	}

	if( ( fp = fopen( pdrname, "rb" ) ) == NULL )
	{
		VC_printf( "'%s'ǂݍ߂܂B\n", POINTER, pdrname );
		return;
	}

	if( fread( file, 1, size, fp ) < size )
	{
		VC_printf( "f[^̓ǂݍ݂Ɏs܂B\n" );
		fclose( fp );
		return;
	}
	fclose( fp );

	file_ = file;

	bufp += addstrings( init, bufp );	/*𑜓x360dpi + p1bytew*/
	setLeftmargin( leftmargin );
	VC_printf( "%dy[WڂłB\n", UL_INT, page );
	while( endflg == OFF )
	{
		lineInit();
		sflg = ON;
		while( lineflg == OFF )
		{
			comflg = OFF;
			ch = (*file++) & 0xff;

			if( file - file_ > size )
			{
				*bufp++ = 0x0a;
				pageflg = ON;
				endflg = ON;
				break;
			}

			if( betaflg == ON )
				goto LABEL01;

			if( sflg == ON && ch == '#' )
			{
				control = ON;
				continue;
			}
			sflg = OFF;
			if( ch == '}' && np > 1 )
			{
				switch( nest[np--] )
				{
					case 10:/*TCY*/
						setKanjiSize( info[np][1] );
						break;
					case 19:/*tHg*/
						setFontType( info[np][0] );
						break;
					case 21:/*A_[C*/
						setUnderline( OFF );
						break;
					case 32:/*sb`*/
						bufp += addstrings( prooff, bufp );
						break;
					case 40:/*Ԋ|*/
						setNetEnd();
						break;
					case 47:/*]*/
						setColorReverse();
						break;
				}
				continue;
			}

			if( ch == '/' )
			{
				for( i=0; i<15; i++ )
					combuf[i] = (*(file+i)) & 0xff;
				combuf[16] = 0;

				switch( getCommand2() )
				{
					case 1:/*p1bytew*/
						bufp += addstrings( hss2, bufp );
						comflg = ON;
						break;
					case 2:/*tJn*/
						if( pool[0] == 0 )
							break;
						incNest( 10 );
						setBaseLine( BL_UPPER );
						setKanjiSize( KS_XH_YH );
						comflg = ON;
						break;
					case 4:/*tJn*/
						if( pool[0] == 0 )
							break;
						incNest( 10 );
						setBaseLine( BL_BOTTOM );
						setKanjiSize( KS_XH_YH );
						comflg = ON;
						break;
					case 6:/*sb`*/
						if( pool[1] == 0 )
							break;
						i = DWORD( pool+2 );
						if( i<48 || i>120 )
							break;
						pitch = i;
						setKanjiPitch( pitch );
						comflg = ON;
						break;
					case 8:/*ssb`*/
						if( pool[1] == 0 )
							break;
						i = DWORD( pool+2 );
						if( i<1 || i>120 )
							break;
						cr_p = i;
						setReturnPitch( cr_p );
						comflg = ON;
						break;
					case 10:/*W*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 2;
						setKanjiSize( KS_XN_YN );
						comflg = ON;
						break;
					case 11:/*{*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 4;
						setKanjiSize( KS_XD_YN );
						comflg = ON;
						break;
					case 12:/*c{*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 2;
						setKanjiSize( KS_XN_YD );
						comflg = ON;
						break;
					case 13:/*c{*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 4;
						setKanjiSize( KS_XD_YD );
						comflg = ON;
						break;
					case 14:/*c*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 2;
						setKanjiSize( KS_XN_YH );
						comflg = ON;
						break;
					case 15:/**/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 1;
						setKanjiSize( KS_XH_YN );
						comflg = ON;
						break;
					case 16:/*c{*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 4;
						setKanjiSize( KS_XD_YH );
						comflg = ON;
						break;
					case 17:/*c{*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 1;
						setKanjiSize( KS_XH_YD );
						comflg = ON;
						break;
					case 18:/*c*/
						if( pool[0] )
							incNest( 10 );
						pitchmask = 1;
						setKanjiSize( KS_XH_YH );
						comflg = ON;
						break;
					case 19:/*SVbN*/
						if( pool[0] )
							incNest( 19 );
						setFontType( 1 );
						comflg = ON;
						break;
					case 20:/**/
						if( pool[0] )
							incNest( 19 );
						setFontType( 0 );
						comflg = ON;
						break;
					case 21:/*A_[Cw*/
						if( ! pool[0] )
							break;
						incNest( 21 );
						setUnderline( ON );
						comflg = ON;
						break;
					case 27:/*rڑw*/
						setLineConnect( ON );
						comflg = ON;
						break;
					case 28:/*rڑ*/
						setLineConnect( OFF );
						comflg = ON;
						break;
					case 29:/*c{[킹*/
						setBaseLine( 0 );
						comflg = ON;
						break;
					case 30:/*c{[킹*/
						setBaseLine( 1 );
						comflg = ON;
						break;
					case 31:/*c{S킹*/
						setBaseLine( 2 );
						comflg = ON;
						break;
					case 32:/*sb`w*/
						if( pool[0] == 0 )
							break;
						bufp += addstrings( proon, bufp );
						incNest( 32 );
						comflg = ON;
						break;
					case 38:/*y[WύX*/
						pageflg = ON;
						comflg = ON;
						break;
					case 39:/*tg}[Ww*/
						if( pool[1] == 0 )
							break;
						i = DWORD( pool+2 );
						if( i<0 || i>80 )
							break;
						setLeftmargin( i );
						leftmargin = i;
						comflg = ON;
						break;
					case 40:/*Ԋ|*/
						if( pool[1] == 0 || pool[0] == 0 )
							break;
						net_sort = DWORD( pool+2 );
						if( net_sort<0 || net_sort>4 )
							break;
						setNetStart();
						incNest( 40 );
						comflg = ON;
						break;
					case 41:/*cw*/
						setPrintDirection( 1 );
						comflg = ON;
						break;
					case 42:/*w*/
						setPrintDirection( 0 );
						comflg = ON;
						break;
					case 43:/*ѕM*/
						if( pool[0] )
							incNest( 19 );
						setFontType( 2 );
						comflg = ON;
						break;
					case 44:/*ە*/
						if( pool[0] )
							incNest( 19 );
						setFontType( 3 );
						comflg = ON;
						break;
					case 45:/*ȏ*/
						if( pool[0] )
							incNest( 19 );
						setFontType( 4 );
						comflg = ON;
						break;
					case 46:/*JISw*/
						if( pool[1] == 0 )
							break;
						jiscode = DWORD( pool+2 );
						goto D_JIS_IN;
						break;
					case 47:/*]*/
						if( pool[0] )
							incNest( 47 );
						setColorReverse();
						comflg = ON;
						break;
					case 48:/*^uTCYw*/
						if( pool[1] == 0 )
							break;
						i = DWORD( pool+2 );
						if( i<0 || i>8 )
							break;
						tabsize = i;
						comflg = ON;
						break;
				}
				if( comflg == ON )
					continue;

				ch = (*file++) & 0xff;
			}
LABEL01:
			if( ch == 0x0a )
			{
				if( control == OFF )
				{
					if( net_flg == ON )
						net_length = x_pos - net_sp;
					if( net_length > 0 )
						printNet();
					*bufp++ = 0x0a;
				}
				lineflg = ON;
				break;
			}

			if( control )
				continue;

			if( ch == 0x09 )
			{
				setAsciiMode();
				do
				{
					addstrings( "\x20", bufp );
					bufp ++;
					x_pos += pitch*pitchmask/4;
				}
				while( ( ( x_pos - leftmargin*27 )/ (pitch/2) ) % tabsize );

				continue;
			}

			if( ch>0xe0 || (ch>0x80 && ch<0xa0) )
			{
				moji.c[1] = (unsigned char)ch;
				moji.c[0] = (unsigned char)(*file) & 0xff;
				file++;

				jiscode = FNT_sjisToJis( (int)moji.sjis );
D_JIS_IN:
				setKanjiMode();
				moji.sjis = (unsigned short int)jiscode;
				i = ( moji.c[1] == 0x28 )? 0: info[np][0];
				switch( i )
				{
					case 0:/**/
						if( colrev_flg == OFF )
							break;
						if( mint_flg == OFF )
							break;
						fseek( mint_fp, ((moji.c[1]-0x21)*94+(moji.c[0]-0x21)+128)*288+16, SEEK_SET );
						fread( gjbuf, 1, 288, mint_fp );
						break;
					case 1:/*SVbN*/
						if( colrev_flg == OFF )
							break;
						if( goth_flg == OFF )
							break;
						fseek( goth_fp, ((moji.c[1]-0x21)*94+(moji.c[0]-0x21)+128)*288+16, SEEK_SET );
						fread( gjbuf, 1, 288, goth_fp );
						break;
					case 2:/*ѕM*/
						if( mouh_flg == OFF )
							break;
						fseek( mouh_fp, ((moji.c[1]-0x21)*94+(moji.c[0]-0x21)+128)*288+16, SEEK_SET );
						fread( gjbuf, 1, 288, mouh_fp );
						break;
					case 3:/*ە*/
						if( maru_flg == OFF )
							break;
						fseek( maru_fp, ((moji.c[1]-0x21)*94+(moji.c[0]-0x21))*74+18, SEEK_SET );
						fread( gjbuf2, 1, 72, maru_fp );
						convert24to48( gjbuf2, gjbuf );
						break;
					case 4:/*ȏ*/
						if( kyou_flg == OFF )
							break;
						fseek( kyou_fp, ((moji.c[1]-0x21)*94+(moji.c[0]-0x21))*74+18, SEEK_SET );
						fread( gjbuf2, 1, 72, kyou_fp );
						convert24to48( gjbuf2, gjbuf );
						break;
				}

				if( ( i != 0 && i != 1 ) || ( colrev_flg == ON ) )
				{
					*(defgj+5) = (usrjis>>8)&0xff;
					*(defgj+6) = (usrjis)&0xff;
					bufp += addstrings( defgj, bufp );

/*					if( colrev_flg == ON )
					{
						for( i=0; i<72; i++ )
							DWORD( gjbuf+i*4 ) ^= 0xffffffff;
					}????ŃnOAbv????*/

					memcpy( bufp, gjbuf, 288 );
					bufp += 288;

					moji.sjis = (unsigned short int)usrjis;
					++ usrjis;
				}

				*bufp++ = moji.c[1];
				*bufp++ = moji.c[0];
				x_pos += pitch*pitchmask/2;
			}
			else
			{
				setAsciiMode();
				*bufp++ = (char)ch;
				x_pos += pitch*pitchmask/4;
			}
		}

		if( flushBuffer() )
			break;

		lineTerm();
		if( ! control )
			++ lnum;
		if( lnum == lpp )
			pageflg = ON;

		if( pageflg == ON )
		{
			lnum = 0;
			if( writepage == ON )
			{
				printPage( page );
				if( flushBuffer() )
					break;
			}

			if( endflg == OFF )
			{
				page++;
				y_pos = 0;
				pageflg = OFF;
				printReady( 6 );
				VC_printf( "%dy[WڂłB\n", UL_INT, page );
			}
		}
	}

	VC_printf( "I܂B\n" );
	return;
}
